;*=====================================================================*/
;*    serrano/prgm/project/bigloo/bmacs/bdb-config.el                  */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Thu Apr 30 13:30:57 1998                          */
;*    Last change :  Thu Oct 15 16:13:14 1998 (serrano)                */
;*    -------------------------------------------------------------    */
;*    The user configuration file.                                     */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(provide 'bdb-config)

;; the binary files
(defcustom bdb-binary "bdb"
  "The name of the binary executable bdb file."
  :group 'bdb
  :type 'string)

;; window configuration (colors, margin size, ...)
(defcustom bdb-margin-color "bisque"
  "The color for the left margin."
  :group 'bdb
  :type 'string)

(defcustom bdb-margin-width 3
  "The widh of the left bdb margin."
  :group 'bdb
  :type 'number)

(defcustom bdb-stack-depth 10
  "The number of stack frame to be displayed (or nil for all stack)."
  :group 'bdb
  :type 'number)

(defcustom bdb-display-height 10
  "The display frame height."
  :group 'bdb
  :type 'number)

(defcustom bdb-args-height 10
  "The args display frame height."
  :group 'bdb
  :type 'number)

(defcustom bdb-locals-height 10
  "The locals frame height."
  :group 'bdb
  :type 'number)

(defcustom bdb-output-color "blue4"
  "The color for bdb outputs."
  :group 'bdb
  :type 'string)

(defcustom bdb-prompt-face 'font-lock-function-name-face
  "The face to display the bdb prompt"
  :group 'bdb
  :type 'symbol)

(defcustom bdb-scheme-io-face nil
  "*Non-nil means face to display the process output."
  :group 'bdb
  :type 'boolean)

(defcustom bdb-bdb-io-face 'font-lock-comment-face
  "*Non-nil means The face to display the process output."
  :group 'bdb
  :type 'symbol)

(defcustom bdb-scheme-frame-face 'font-lock-face-2
  "The face to display Scheme stack frames."
  :group 'bdb
  :type 'symbol)

(defcustom bdb-c-frame-face 'font-lock-face-3
  "The face to display C stack frames."
  :group 'bdb
  :type 'symbol)

(defcustom bdb-hilit-io-p t
  "*Non-nil means to hilit non bdb output."
  :group 'bdb
  :type 'boolean)

;; key bindings
(defcustom bdb-mouse-binding [(button3)]
  "*The mouse binding for Bdb mouse event."
  :group 'bdb
  :type 'vector)

;; balloon configuration
(defcustom bdb-balloon-timeout 1000
  "Display balloon after this many milliseconds of mouse inactivity."
  :group 'bdb
  :type 'number)

(defcustom bdb-balloon-width 80
  "The maximum number of chars displayed in a balloon window."
  :group 'bdb
  :type 'number)

;; bdb config
(defcustom bdb-wait-output-timeout 2
  "The number of seconds before timeout when waiting for bdb output."
  :group 'bdb
  :type 'number)

(defcustom bdb-verbose-remote t
  "*Non-nil means that remote call are printed and registered in the history."
  :group 'bdb
  :type 'boolean)

(defcustom bdb-balloon-enabled-modes '(scheme-mode c-mode)
  "The list of emacs mode enabled has source file mode."
  :group 'bdb
  :type '(repeat (symbol)))

(defcustom bdb-window-height 15
  "The number of lines of the bdb console window."
  :group 'bdb
  :type 'number)

(defcustom bdb-display-source-in-frame-p t
  "*Non-nil means that source file are displayed in a separate frame."
  :group 'bdb
  :type 'boolean)

;; bdb show
(defcustom bdb-show '(local args stack)
  "*A list of elements that may be LOCAL, ARGS, DISPLAY or STACK."
  :group 'bdb
  :type '(repeat (symbol)))

;; prompt
(defcustom bdb-prompt-regexp "(bdb) "
  "The bdb prompt."
  :group 'bdb
  :type 'string)

(defcustom bdb-prompt-eol-regexp (concat bdb-prompt-regexp "$")
  "The regexp matching bdb prompt on a line."
  :group 'bdb
  :type 'string)


