;*=====================================================================*/
;*    serrano/prgm/project/bigloo/bmacs/bdb-console.el                 */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Fri Aug 14 09:20:08 1998                          */
;*    Last change :  Fri Aug 14 11:00:36 1998 (serrano)                */
;*    -------------------------------------------------------------    */
;*    This file is for debugging because I'm not able to understand    */
;*    the causality used by comint. I made this small file to trace    */
;*    what bdb is waiting for.                                         */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(provide 'bdb-console)

;*---------------------------------------------------------------------*/
;*    bdb-console-buffer ...                                           */
;*---------------------------------------------------------------------*/
(defvar bdb-console-buffer nil
  "*The buffer for the bdb console or nil if the console as
not been launched yet.")

;*---------------------------------------------------------------------*/
;*    bdb-console-get-buffer ...                                       */
;*---------------------------------------------------------------------*/
(defun bdb-console-get-buffer ()
  (setq bdb-console-buffer (get-buffer-create "*bdb console*")))

;*---------------------------------------------------------------------*/
;*    bdb-pop-console ...                                              */
;*    -------------------------------------------------------------    */
;*    Raise the bdb console buffer or create one if none exists.       */
;*---------------------------------------------------------------------*/
(defun bdb-pop-console ()
  (interactive)
  (let ((buffer (current-buffer)))
    (if (bufferp bdb-console-buffer)
	(let ((win (get-buffer-window bdb-console-buffer t)))
	  (if (not (windowp win))
	      (pop-to-buffer bdb-console-buffer)))
      (progn
	(bdb-console-get-buffer)
	(pop-to-buffer bdb-console-buffer)))
    (set-buffer buffer)))

;*---------------------------------------------------------------------*/
;*    bdb-console-log-number ...                                       */
;*---------------------------------------------------------------------*/
(defvar bdb-console-log-number 0)

;*---------------------------------------------------------------------*/
;*    bdb-console-log ...                                              */
;*---------------------------------------------------------------------*/
(defun bdb-console-log (prompt msg &optional face)
  (save-window-excursion
    ;; we first allocate a buffer for the logs
    (if (not (bufferp bdb-console-buffer))
	(bdb-console-get-buffer))
    (setq bdb-console-log-number (+ 1 bdb-console-log-number))
    (if face
	(put-text-property 0 (length msg) 'face face msg))
    (set-buffer bdb-console-buffer)
    (goto-char (point-max))
    (let ((num (format "%s (log num %d):\n" prompt bdb-console-log-number)))
      (insert num))
    (insert msg)
    (insert "\n\n"))
  (let ((win (get-buffer-window bdb-console-buffer)))
    (if (windowp win)
	(set-window-point win (point-max)))))

;*---------------------------------------------------------------------*/
;*    bdb-erase-console ...                                            */
;*---------------------------------------------------------------------*/
(defun bdb-erase-console ()
  (interactive)
  (set-buffer bdb-console-buffer)
  (erase-buffer))

;*---------------------------------------------------------------------*/
;*    bdb-recenter-console ...                                         */
;*---------------------------------------------------------------------*/
(defun bdb-recenter-console ()
  (interactive)
  (let ((win (get-buffer-window bdb-console-buffer)))
    (if (windowp win)
	(set-window-point win (point-max)))))

  
  

