;*=====================================================================*/
;*    serrano/prgm/project/bigloo/bmacs/bdb-docline.el                 */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Mon Jun  1 07:58:46 1998                          */
;*    Last change :  Fri Aug 21 12:59:59 1998 (serrano)                */
;*    -------------------------------------------------------------    */
;*    The Bdb online documentation. This file uses `xinfo' for         */
;*    displaying Info files.                                           */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(provide 'bdb-docline)
(require 'bee-tools)
(require 'info)

;*---------------------------------------------------------------------*/
;*    bdb-info-file ...                                                */
;*---------------------------------------------------------------------*/
(defvar bdb-info-file
  "bdb.info"
  "The name for the bdb info file.")

;*---------------------------------------------------------------------*/
;*    bdb-pop-to-info ...                                              */
;*    -------------------------------------------------------------    */
;*    Pop up a buffer displaying an info file.                         */
;*---------------------------------------------------------------------*/
(defun bdb-pop-to-info ()
  (let ((pop-up-frames t))
    (pop-to-buffer "*info*")))

;*---------------------------------------------------------------------*/
;*    bdb-info-ref-internal ...                                        */
;*    -------------------------------------------------------------    */
;*    Search in the info documentation for a function (or variable)    */
;*    definition.                                                      */
;*---------------------------------------------------------------------*/
(defun bdb-info-ref-internal (ident)
  (save-window-excursion
    (info)
    (Info-find-node bdb-info-file "Top")
    (if (not (string= ident ""))
	(Info-index ident)))
  (bdb-pop-to-info))

;*---------------------------------------------------------------------*/
;*    bdb-fetch-then-request-identifier ...                            */
;*---------------------------------------------------------------------*/
(defun bdb-fetch-then-request-identifier (pos prompt)
  (let ((char (char-after (point)))
	(word (current-word)))
    (if (or (not char)
	    (eq char ?\ )
	    (string= word ""))
	(read-string prompt)
      word)))

;*---------------------------------------------------------------------*/
;*    bdb-docline ...                                                  */
;*    -------------------------------------------------------------    */
;*    This function calls an online documentation with respect         */
;*    to the active context.                                           */
;*    -------------------------------------------------------------    */
;*    If a region is active, this function print the documentation     */
;*    for the region.                                                  */
;*---------------------------------------------------------------------*/
(defun bdb-docline ()
  "Popup an online documentation according to context."
  (interactive)
  (bdb-info-ref-internal (bdb-fetch-then-request-identifier (point)
							    "help for: ")))
	 
	    
