;*=====================================================================*/
;*    serrano/prgm/project/bigloo/bmacs/bdb-process.el                 */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Sun Apr 19 15:08:24 1998                          */
;*    Last change :  Fri Aug 21 09:34:58 1998 (serrano)                */
;*    -------------------------------------------------------------    */
;*    The bdb process management.                                      */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(provide 'bdb-process)
(require 'bdb-config)
(require 'bdb)

;*---------------------------------------------------------------------*/
;*    bdb-sentinel ...                                                 */
;*    -------------------------------------------------------------    */
;*    This function is called when the bdb running process changes     */
;*    of state. This means that the process has been killed or         */
;*    stopped or anything else like that.                              */
;*---------------------------------------------------------------------*/
(defun bdb-sentinel (proc msg)
  (cond
   ((null (buffer-name (process-buffer proc)))
    ;; the buffer has been killed. We stop displaying
    ;; arrow in the source files.
    (set-process-buffer proc nil))
   ((memq (process-status proc) '(signal exit))
    (let ((msg (format "KILLING bdb because: %S %S" proc msg)))
      (put-text-property 0 (length msg)
			 'face
			 bdb-scheme-frame-face
			 msg)
      (display-message 'no-log msg)
      (let ((window (get-buffer-window bdb-comint-buffer t)))
	(if (one-window-p window)
	    (let ((frame (window-frame window)))
	      (delete-frame frame))))
      (kill-buffer bdb-comint-buffer)
      (setq bdb-comint-buffer nil)))))

	  
