;*=====================================================================*/
;*    serrano/prgm/project/bigloo/emacs/bee-mouse.el                   */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Thu Aug  6 11:16:17 1998                          */
;*    Last change :  Thu Aug  6 12:05:25 1998 (serrano)                */
;*    -------------------------------------------------------------    */
;*    The mouse binding (common to bee and bdb).                       */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(provide 'bee-mouse)

;*---------------------------------------------------------------------*/
;*    bee-predicate-menus ...                                          */
;*---------------------------------------------------------------------*/
(defvar bee-predicate-menus '()
  "*The list of predicate menus.
A predicate menu is a pair (PRED . MENU).
PRED is a predicate with of one argument, an EVENT.
MENU is a function that popups a menu.")
(make-variable-buffer-local 'bee-predicate-menus)

;*---------------------------------------------------------------------*/
;*    bee-add-menu ...                                                 */
;*---------------------------------------------------------------------*/
(defun bee-add-menu (pred menu)
  (setq bee-predicate-menus (cons (cons pred menu) bee-predicate-menus)))

;*---------------------------------------------------------------------*/
;*    bee-predicate-mouse-event ...                                    */
;*---------------------------------------------------------------------*/
(defun bee-predicate-mouse-event (event)
  (interactive "e")
  (let ((l bee-predicate-menus))
    (while (consp l)
      (if (funcall (car (car l)) event)
	  (progn
	    (funcall (cdr (car l)) event)
	    (setq l nil))
	(setq l (cdr l))))))



